import argparse
import functools
from typing import NamedTuple, List, Dict, Set

parser = argparse.ArgumentParser()
parser.add_argument("ifile", type=argparse.FileType('r'))
args = parser.parse_args()

heightmap = [[int(x) for x in line.strip()] for line in args.ifile.readlines()]

def printMap(map: List[List]):
    for line in map:
        print("".join([str(int(el)) for el in line]))

def descendingMap(seq: int) -> List[bool]:
    return [True] + list(map(lambda pair: pair[0] < pair[1], zip(seq[1:], seq)))

right = map(descendingMap, heightmap)
left = map(lambda line: reversed(descendingMap(list(reversed(line)))), heightmap)
horiz = [[all(pair) for pair in line] for line in map(lambda pair: zip(pair[0], pair[1]), zip(right, left))]

# transpose array to check cols
flipped = [[heightmap[j][i] for j in range(len(heightmap))] for i in range(len(heightmap[0]))]

up = map(descendingMap, flipped)
down = map(lambda line: reversed(descendingMap(list(reversed(line)))), flipped)
pre_vert = [[all(pair) for pair in line] for line in map(lambda pair: zip(pair[0], pair[1]), zip(up, down))]
# transpose back
vert = [[pre_vert[j][i] for j in range(len(pre_vert))] for i in range(len(pre_vert[0]))]

composite = [[all(pair) for pair in line] for line in map(lambda pair: zip(pair[0], pair[1]), zip(horiz, vert))]

paired = [[pair[0] + 1 if pair[1] else 0 for pair in line] for line in map(lambda pair: zip(pair[0], pair[1]), zip(heightmap, composite))]

print(sum(map(sum, paired)))